/************************************************************************
*  This file is part of the KDE project, module kcontrol.               *
*  Copyright (C) 2007 Ian Ventura-Whiting <fizz@titania.co.uk>          *
*                                                                       *
*  You can Freely distribute this program under the GNU LGPL version 2  *
*************************************************************************/

#ifndef __DataSources_h_Included__
#define __DataSources_h_Included__

#include <QObject>
#include <kcmodule.h>

class QTreeWidget;
class KPushButton;


// Data Sources
class KDataSources: public KCModule
{
	Q_OBJECT

	public:
		KDataSources(QWidget *parent, const QStringList &args);
		~KDataSources();

		void load();

	private slots:
		// Slots...
		void addDSN();
		void removeDSN();
		void dsnSelectionChanged();

	private:
		// Update DSN...
		void updateDSNList(int dsnType);
		void updateFileDSNList();

		// Widgets...
		QTreeWidget *dataSourceList;
		KPushButton *addDSNButton;
		KPushButton *modifyDSNButton;
		KPushButton *removeDSNButton;
		KPushButton *testDSNButton;
};

#endif // __DataSources_h_Included__
