/**
 *  Copyright (C) 2004 Benjamin C Meyer (ben+thistest at meyerhome dot net)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Steet, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

/**
 * TEST: Unecessary usage of this->
 * 
 * When compiled with optimizations the two times should be the same
 * When compiled without optimizations this-> will be about 1/2 the speed 
 */

#include <qobject.h>
#include <sys/time.h>

class ThisNameWidget : QObject {
	public:
		ThisNameWidget(QObject * parent = 0, const char * name = 0):QObject(parent, name) {  const char *s; s = (this->name()); };
};

class NameWidget : QObject {
  public:
   NameWidget(QObject * parent = 0, const char * n = 0):QObject(parent, n) {  const char *s; s =name(); };
};


#define LOOP 200000

/**
 * Read in paramaters and output a maze line by line.
 */
int main( int argc, char *argv[] ) {
	struct timeval tv1;
	struct timeval tv2;
	struct timeval result;

	qDebug("%d iterations", LOOP);
	qDebug("PASS 1");

	gettimeofday(&tv1, NULL);
	for(uint i=0; i < LOOP; i++){
		ThisNameWidget a;
	}
  gettimeofday(&tv2, NULL);
	timersub(&tv2, &tv1, &result);
	qDebug("    Using this-> took %lu.%06lu seconds", result.tv_sec, result.tv_usec);
	
	gettimeofday(&tv1, NULL);
	for(uint i=0; i < LOOP; i++){
		NameWidget a;
	}
	gettimeofday(&tv2, NULL);
	timersub(&tv2, &tv1, &result);
	qDebug("Not using this-> took %lu.%06lu seconds", result.tv_sec, result.tv_usec);

	qDebug("PASS 2, REVERSING ORDER");

	gettimeofday(&tv1, NULL);
	for(uint i=0; i < LOOP; i++){
		NameWidget a;
	}
	gettimeofday(&tv2, NULL);
	timersub(&tv2, &tv1, &result);
	qDebug("Not using this-> took %lu.%06lu seconds", result.tv_sec, result.tv_usec);

	gettimeofday(&tv1, NULL);
	for(uint i=0; i < LOOP; i++){
		ThisNameWidget a;
	}
  gettimeofday(&tv2, NULL);
	timersub(&tv2, &tv1, &result);
	qDebug("    Using this-> took %lu.%06lu seconds", result.tv_sec, result.tv_usec);
	
	return 0;
}

// vim: set ts=2:
