/*******************************************************************************
 *                                                                             *
 * klbSearchbar is a toolbar plugin for konqueror to use search functionality  *
 * of klb                                                                      *
 * Copyright (C) 2005  Ramakrishna R <coolrama@gmail.com>                      *
 *                                                                             *
 * This program is free software; you can redistribute it and/or modify        *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation; either version 2 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program; if not, write to the Free Software                 *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. *
 *                                                                             *
 ******************************************************************************/



#ifndef KLB_SEARCHBAR_PLUGIN
#define KLB_SEARCHBAR_PLUGIN

#include <qstring.h>
#include <kparts/plugin.h>
#include <kparts/mainwindow.h>
#include <kcombobox.h>
#include <klibloader.h>

class KHTMLPart;

class KlbSearchBarc : public KHistoryCombo
{
	Q_OBJECT

	private:
		bool    _pluginActive;
	
	public slots:
		virtual void show();

	public:
		KlbSearchBarc(QWidget *parent, const char *name);
		const QPixmap &icon() const;
		void setPluginActive(bool pluginActive);
};

class KlbSearchBarPlugin : public KParts::Plugin
{
	Q_OBJECT
	
	private:
		QGuardedPtr<KHTMLPart> _part;
		KlbSearchBarc        *_searchCombo;
                KWidgetAction         *_searchComboAction;
//		bool                   _urlEnterLock;

	private slots:
		void search(const QString &search);
		void partChanged(KParts::Part *newPart);
		void updateVisibility();

	public:
		KlbSearchBarPlugin(QObject *parent, const char *name,
		                const QStringList &);
		virtual ~KlbSearchBarPlugin();

};

#endif 
