/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KLIPPER_ENGINE_H
#define KLIPPER_ENGINE_H

#include <Plasma/DataEngine>

namespace Plasma
{
    class Service;
}

class KlipperEngine : public Plasma::DataEngine
{
    Q_OBJECT

public:
    KlipperEngine(QObject* parent, const QVariantList& args);
    ~KlipperEngine();

private:
    void init();
    virtual Plasma::Service* serviceForSource(const QString& source);

private slots:
    void onClipEntryAdded(const QString&);
    void onClipEntryRemoved(const QString&);
    void onClipCurrentEntryChanged(const QString&);
};

K_EXPORT_PLASMA_DATAENGINE(klipper, KlipperEngine)

#endif
