/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef MERGER_H
#define MERGER_H

#include <QObject>

namespace Nepomuk {

    namespace Sync {
        class ChangeLog;
    }
    class MergeThread;

    class Merger : public QObject
    {
        Q_OBJECT
        Q_CLASSINFO("D-Bus Interface", "org.kde.nepomuk.services.nepomukbackupsync.Merger")

    public :
        Merger( QObject* parent = 0 );
        virtual ~Merger();

    public Q_SLOTS:
        int process( const Nepomuk::Sync::ChangeLog & logFile );

    Q_SIGNALS:
        void completed( int percent );
        void multipleMerge( const QString & uri, const QString & prop );

    private :
        MergeThread * m_mergeThread;
    };

}

#endif // MERGER_H
