/*
    This file is part of the Nepomuk KDE project.
    Copyright (C) 2010  Vishesh Handa <handa.vish@gmail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef LOGFILEHASH_H
#define LOGFILEHASH_H

#include <QMultiHash>
#include <QDateTime>
#include <QUrl>

#include <Soprano/Node>

namespace Nepomuk {

    class LogFile;

    struct LogFileHashStruct {
        Soprano::Node object;
        QDateTime dt;
        bool added;
    };

    typedef QMultiHash<QUrl, LogFileHashStruct> LogFilePropHash;
    typedef QMultiHash<QUrl, LogFilePropHash> LogFileHash;

    LogFileHash convertToLogFileHash( const LogFile & logFile );
}
#endif // LOGFILEHASH_H
