/* This file is part of the Nepomuk Project
   Copyright (c) 2009 Alessandro Sivieri <alessandro.sivieri@gmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef KONQNEPOMUKPLUGIN_H_
#define KONQNEPOMUKPLUGIN_H_

#include <QStringList>

#include <konq_popupmenu.h>
#include <konq_popupmenuplugin.h>
#include <konq_popupmenuinformation.h>

class KonqNepomukPlugin : public KonqPopupMenuPlugin
{
    Q_OBJECT
    
public:
    KonqNepomukPlugin(KonqPopupMenu* popupMenu, const QStringList& list);
    virtual ~KonqNepomukPlugin();

    void setup(KActionCollection* actionCollection, const KonqPopupMenuInformation& popupMenuInfo, QMenu* menu);

public Q_SLOTS:
    void showSharingDialog();
    void share();
    
private:
    QStringList m_files;
};

#endif /* KONQNEPOMUKPLUGIN_H_ */
