#include "fileresourceeditplugin.h"
#include "nfo.h"

#include "../src/propertyeditwidget.h"

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QList>
#include <QPalette>
#include <QColor>
#include <QLabel>

#include <Nepomuk/Types/Property>
#include <Nepomuk/Variant>

#include <KPluginFactory>
#include <KPluginLoader>
#include <KFileItem>
#include <KFileMetaInfo>
#include <KDebug>

K_PLUGIN_FACTORY(FileEditWidgetFactory, registerPlugin<Nepomuk::FileEditWidget>();)
K_EXPORT_PLUGIN(FileEditWidgetFactory("nepomuk_fileresourceeditplugin"))

Nepomuk::FileEditWidget::FileEditWidget(QWidget *parent, const QList<QVariant>& ) :
        AbstractResourceEditPlugin(parent)
{
}

Nepomuk::FileEditWidget::~FileEditWidget()
{
}

void Nepomuk::FileEditWidget::initGui()
{
    QString s;
    KFileItem fi( KFileItem::Unknown, KFileItem::Unknown, resource().resourceUri() );
    s += fi.name() + ',' + '\n';
    s += fi.localPath() + ',' + '\n';
    s += fi.mimetype() + ',' + '\n';
    s += fi.mimeComment() + ',' + '\n';
    kDebug() << "~~~~~~~~~~~~~~~~~~~~~~~ " << resource().resourceUri().toString() << s;
    KFileMetaInfo metaInfo = fi.metaInfo();
    foreach( KFileMetaInfoItem item, metaInfo.items() ) {
        s += item.name() + ": " + item.value().toString() + '\n';
    }

    this->setLayout(new QVBoxLayout());
    QLabel *l = new QLabel(s);
    layout()->addWidget(l);
}
