/*
Copyright (c) 2010 Oszkar Ambrus <aoszkar@gmail.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef RESOURCEEDITWIDGETWRAPPER_H
#define RESOURCEEDITWIDGETWRAPPER_H

#include <QWidget>
#include "resourceeditwidget.h"

class ResourceEditWidgetWrapper : public QWidget
{
    Q_OBJECT

public:
    ResourceEditWidgetWrapper(QWidget *parent = 0);
    void setResourceEditWidget(Nepomuk::ResourceEditWidget *widget);
    Nepomuk::ResourceEditWidget *resourceEditWidget() const;

private Q_SLOTS:
    /**
     * Changes the interaction mode.
     *
     * When activating editing mode, the Edit button is changed to Save,
     * and Cancel is enabled.
     */
    void btnEnableDisableClicked();

protected:
    void focusInEvent ( QFocusEvent * event );
    void focusOutEvent ( QFocusEvent * event );

private:
   Nepomuk::ResourceEditWidget *m_resourceEditWidget;

   KPushButton *m_btnEnableDisable;
   KPushButton *m_btnSave;
   KPushButton *m_btnRevert;
   bool m_editingEnabled;
};

#endif // RESOURCEEDITWIDGETWRAPPER_H
