#include "field.h"

Field::Field(const QString& name, const QString& field, const QList<comparator>& comparators, widget_factory factory) :
        m_name(name), m_field(field), m_comparators(comparators), m_factory(factory)
{
}


const QString& Field::name() const
{
    return m_name;
}

const QString& Field::field() const
{
    return m_field;
}

const QList<comparator> Field::comparators() const
{
    return m_comparators;
}

ValueWidget* Field::getWidget(QWidget* parent) const
{
    return m_factory(parent);
}
