#ifndef SEARCHCRITERION_H
#define SEARCHCRITERION_H

#include <QList>
#include <QString>
#include <QWidget>

#include "field.h"

class QComboBox;
class QHBoxLayout;
class QPushButton;
class ValueWidget;

class SearchCriterion : public QWidget
{
    Q_OBJECT
public:
    SearchCriterion(QWidget* parent = 0);

    QString getSearchText() const;

public slots:
    void fieldChanged(const QString& field);
    void updateQuery();

signals:
    void removeCriterion();
    void criterionChanged(QString query);

private:
    void populateField();
    const Field& getCurrentField();
    const comparator& getCurrentComparator();

    QHBoxLayout* layout;
    QComboBox* field;
    QComboBox* comp;
    ValueWidget* value;
    QPushButton* remove;

    QString query;
    static void buildFieldList();
    static QList<Field> fields;
};

#endif // SEARCHCRITERION_H
