/*
 * This file is part of Search Project.
 *
 * Copyright (C) 2007 Daniele Galdi <daniele.galdi@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef ITEM_WIDGET_H
#define ITEM_WIDGET_H

#include <QListView>
#include <QModelIndex>

#include <ui_ExpandedItemWidget.h>
#include <ui_ClosedItemWidget.h>

class ExpandedItemWidget : public QWidget, public Ui::ExpandedItemWidget
{
  Q_OBJECT

public:
  explicit ExpandedItemWidget(const QModelIndex &index, QWidget *parent = 0 );
  virtual ~ExpandedItemWidget();

public slots:
  void switchClicked();

signals:
  void stateChanged( const QModelIndex &index ); 

private:
  QModelIndex m_index;
};

class ClosedItemWidget : public QWidget, public Ui::ClosedItemWidget
{
  Q_OBJECT

public:
  explicit ClosedItemWidget(const QModelIndex &index, QWidget *parent = 0 );
  virtual ~ClosedItemWidget();

public slots:
  void switchClicked();

signals:
  void stateChanged( const QModelIndex &index, int state ); 

private:
  QModelIndex m_index;
};

#endif // ITEM_WIDGET_H
