/* This file is part of the Nepomuk Project
 Copyright (c) 2009 Alessandro Sivieri <alessandro.sivieri@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public License
 along with this library; see the file COPYING.LIB.  If not, write to
 the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 Boston, MA 02110-1301, USA.
 */

#include <KApplication>
#include <KAboutData>
#include <KCmdLineArgs>
#include <KUrl>

#include "mainwindow.h"

int main(int argc, char **argv)
{
    KAboutData aboutData("texteditor", 0, ki18n("Smartsave Texteditor"), "0.1",
            ki18n("Text editor for testing smartsave."),
            KAboutData::License_GPL, ki18n("(c) 2009 Alessandro Sivieri"),
            ki18n(""), "http://nepomuk.kde.org/",
            "alessandro.sivieri@gmail.com");
    KCmdLineArgs::init(argc, argv, &aboutData);
    KCmdLineOptions options;
    options.add("+[file]", ki18n("Document to open"));
    KCmdLineArgs::addCmdLineOptions(options);
    KApplication app;
    Test1::MainWindow *window = new Test1::MainWindow();
    window->show();
    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
    if (args->count())
    {
        window->openFile(args->url(0).url());
    }

    return app.exec();
}
