#!/usr/bin/env python
"A simple query service client that allows to perform queries against the Query Service"

import sys
import dbus
import gobject
from dbus.mainloop.glib import DBusGMainLoop
from PyQt4 import QtCore


# The main event loop as a global var so we can end it in finishedListingHandler
loop = gobject.MainLoop()


def newEntriesHandler(entries):
    "Handler for the newEntries signal from the query"
    for entry in entries:
        print 'New entry: %s' % entry[0]


def finishedListingHandler():
    "Handler for the finishedListing signal of the query."
    loop.quit()

    
def main():
    # register the event loop
    DBusGMainLoop(set_as_default=True)

    # get the connection to the service
    bus = dbus.SessionBus()
    queryServiceProxy = bus.get_object('org.kde.nepomuk.services.nepomukqueryservice',
                                       '/nepomukqueryservice')

    # create the query object
    queryProxy = bus.get_object('org.kde.nepomuk.services.nepomukqueryservice',
                                queryServiceProxy.query(sys.argv[1]))

    # connect our handler functions
    queryProxy.connect_to_signal('newEntries',
                                 newEntriesHandler,
                                 dbus_interface='org.kde.nepomuk.Query')
    queryProxy.connect_to_signal('finishedListing',
                                 finishedListingHandler,
                                 dbus_interface='org.kde.nepomuk.Query')

    # run the query
    queryProxy.list(dbus_interface='org.kde.nepomuk.Query')

    # run the event loop until all results are in
    loop.run()


if __name__ == '__main__':
    main()
