/*****************************************************************************
 *   Copyright (C) 2010 by Anselmo Lacerda S. de Melo <anselmolsm@gmail.com> *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 *****************************************************************************/

#include "activitypopup.h"

#include <QGraphicsLinearLayout>
#include <QGraphicsWidget>
#include <QGraphicsItem>

ActivityPopupPrivate::ActivityPopupPrivate(QGraphicsItem *parent)
    : QGraphicsWidget(parent)
{
    m_bar = new ActivityBar(this, QVariantList());
    m_bar->init();

    QGraphicsLinearLayout *layout = new QGraphicsLinearLayout;
    layout->setContentsMargins(0,0,0,0);
    layout->addItem(m_bar);

    setLayout(layout);
}

ActivityPopupPrivate::~ActivityPopupPrivate()
{
}

ActivityPopup::ActivityPopup(QObject *parent, const QVariantList &args)
    : Plasma::PopupApplet(parent, args), d_ptr(new ActivityPopupPrivate(this))
{
}


ActivityPopup::~ActivityPopup()
{
}

void ActivityPopup::init()
{
    setPopupIcon("tab-new");
}

QGraphicsWidget *ActivityPopup::graphicsWidget()
{
    Q_D(ActivityPopup);
    return d;
}

#include "activitypopup.moc"
