/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Copyright (C) 2008 by Dennis Nienhüser <earthwings@gentoo.org>        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "picturecell.h"

#include <QtGui/QGraphicsLinearLayout>

#include "kdebug.h"

PictureCell::PictureCell(const QString id, const QVariantMap &properties,
		QGraphicsWidget *parent) :
	AbstractCell(parent), m_id(id)
{
	m_label = new Plasma::Label();
	m_label->setMinimumSize(QSizeF(48, 48));

	QGraphicsLinearLayout *layout = new QGraphicsLinearLayout(Qt::Horizontal);
	setLayout(layout);
	layout->addItem(m_label);

	propertiesChanged(properties);
}

PictureCell::~PictureCell()
{
	m_label->deleteLater();
}

void PictureCell::propertiesChanged(const QVariantMap &properties)
{
	// TODO: compare to old state and animate?
	m_label->setImage(properties[m_id].toString());
}
