#include "Ui_CpuFreq.h"
#include <KDebug>
namespace Ui {
	CpuFreq::CpuFreq(PlasmaCpufreq *_top) : Plasma::Dialog(), top(_top) {
		setupUi(this);		
		kDebug() << "Init\n";
		connect(govlistView, SIGNAL(itemPressed(QListWidgetItem*)), this, SLOT(changedSelectiongov(QListWidgetItem*)));
		connect(freqlistView, SIGNAL(itemPressed(QListWidgetItem*)), this, SLOT(changedSelectionfreq(QListWidgetItem*)));
		connect(cpulistView, SIGNAL(itemPressed(QListWidgetItem*)), this, SLOT(changedSelectioncpu(QListWidgetItem*)));
	}
	void CpuFreq::ChangedSelection(QString selection) {
		kDebug() << "changed selection to: " << selection  << " Of cpu: " << top->cpu;
		bool hasMhz = selection.contains("MHz");
		bool hasGhz = selection.contains("GHz");
		if(hasMhz || hasGhz) {
			QList<plasma_tools::FrequencyMap>::iterator iter = freqmap.begin();
			for(;iter != freqmap.end();iter++) {
				if( (*iter).modified == selection) {
					QString launchCommand = QString("cpufreq-set -c %s -g userspace").replace("%s", QString::number(top->cpu));
					kDebug() << launchCommand << " " << plasma_tools::runCommand(launchCommand);
					launchCommand = "cpufreq-set -c " + QString::number(top->cpu) + " -f " + (*iter).orig;
					kDebug() << launchCommand << plasma_tools::runCommand(launchCommand);
					break;
				}
			}
		} else {
			QString launchCommand = "cpufreq-set -c " + QString::number(top->cpu) + " -g " + selection;
			QString worked = plasma_tools::runCommand(launchCommand);
			kDebug() << launchCommand << plasma_tools::runCommand(launchCommand);;
		}
	}
}

#include "../includes/Ui_CpuFreq.moc"
