/***************************************************************************
 *   Copyright (C) 2009 by Matthieu Gallien <matthieu_gallien@yahoo.fr>    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef STATUS_NOTIFIER_ITEM_MODEL_HEADER
#define STATUS_NOTIFIER_ITEM_MODEL_HEADER

#include <Plasma/DataEngine>
#include <QAbstractListModel>
#include <QModelIndex>

class StatusNotifierItemModel : public QAbstractListModel
{
    Q_OBJECT
public:
    StatusNotifierItemModel(Plasma::DataEngine *tasksEngine,
                            QObject *parent = 0);

    virtual ~StatusNotifierItemModel();

    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;

    int rowCount(const QModelIndex &index = QModelIndex()) const;

protected slots:

    void itemAdded(const QString &taskName);

    void itemRemoved(const QString &taskName);

    void dataUpdated(const QString &taskName, const Plasma::DataEngine::Data &taskData);

protected:

    void addItem(const QString &taskName, const Plasma::DataEngine::Data &taskData);

    void removeIndex(int removedIndex);

private:

    Plasma::DataEngine *m_engine;
    QHash<QString, Plasma::DataEngine::Data> m_itemsData;
    QHash<QString, int> m_indexFromItemName;
    QVector<QString> m_itemNameFromIndex;
};

#endif
