/***************************************************************************
 *   Copyright © 2009 Reza Fatahilah Shah <rshah0385@kireihana.com>        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/
#include "previewwidget.h"
#include "infowidget.h"
#include <KDebug>
#include <QPainter>
#include <QTimer>
#include <QLabel>
#include <QStyleOptionGraphicsItem>
#include <QGraphicsSceneResizeEvent>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <Plasma/Svg>
#include <Plasma/Label>
#include "videoproxywidget.h"

PreviewWidget::PreviewWidget(QGraphicsItem * parent, Qt::WindowFlags wFlags)
        : QGraphicsWidget(parent, wFlags)
{
    mInfoAreaHeight = 56;
    mSvg = new Plasma::Svg(this);
    mSvg->setImagePath("widgets/keren");
    mInfoWidget = new InfoWidget(this,mSvg);
    mInfoAreaMargin = QRect(10,0,10,5); //left,top,right,bottom margin
    mVideoWidget = new VideoProxyWidget(this,"xvimagesink");
    connect(mInfoWidget, SIGNAL(countDownFinished()), this, SLOT(slotCountDownFinished()));
}

PreviewWidget::~PreviewWidget()
{
}

void PreviewWidget::resizeEvent(QGraphicsSceneResizeEvent *event)
{
    QSizeF size = contentsRect().size();
    mVideoWidget->resize(size);
    mInfoWidget->setSize(QSizeF(size.width()-2*mInfoAreaMargin.left(),mInfoAreaHeight));
    mInfoWidget->setPos(mInfoAreaMargin.left(),size.height()-mInfoAreaHeight- mInfoAreaMargin.bottom());
}

void PreviewWidget::startCountDownTimer(int counter)
{
    mInfoWidget->startCountDown(3);
}

void PreviewWidget::slotCountDownFinished()
{
    emit countDownFinished();
}
#include "previewwidget.moc"