/*
 * This file is part of the KDE project
 * Copyright (C) 2009 Eva Brucherseifer <eva.brucherseifer@basyskom.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef CONFIGVIEW_H
#define CONFIGVIEW_H

#include <QTreeWidget>
#include <QListWidget>

class KillSwitchManager;
class QToolButton;


class SwitchSelector : public QListWidget
{
  Q_OBJECT

  public:
    SwitchSelector( QWidget *parent );
    ~SwitchSelector();
};

class ConfigView : public QWidget
{
  Q_OBJECT

  public:
    ConfigView( QWidget *parent, KillSwitchManager *mgr );

  public slots:
    void configAccepted();
    void slotSelectionChanged( QListWidgetItem *item );
    void slotMoveUp();
    void slotMoveDown();

  protected:
    void load();
    void save();

  private:
    SwitchSelector *m_switchSelector;
    QToolButton *m_upButton;
    QToolButton *m_downButton;

    KillSwitchManager *p_mgr;
};

#endif
