/*****************************************************************************
 *   Copyright (C) 2008 by Ben Cooksley <ben@eclipse.endoftheinternet.org>   *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 ****************************************************************************/

#include "quizquestion.h"

#include <QLabel>
#include <QRadioButton>

QuizQuestion::QuizQuestion(QGraphicsWidget *parent) : Plasma::GroupBox(parent)
{ // Set text for static buttons
    submit.setText(i18n("Next Question"));
    abort.setText(i18n("Abort Quiz"));
    // Layout
    layout = new QGraphicsGridLayout();
    layout->addItem(&question, 0, 0, 1, 3, Qt::AlignCenter);
    question.nativeWidget()->setAlignment(Qt::AlignCenter);
    for (int layoutWidget = 0; layoutWidget < 4; layoutWidget = layoutWidget + 1) {
        layout->addItem(&chooseAnswer[layoutWidget], layoutWidget + 1, 0, 1, 3, Qt::AlignCenter);
    }
    /// WARNING: Hack to workaround bug in Plasma::RadioButton
    for (int plasmaHack = 0; plasmaHack < 4; plasmaHack = plasmaHack + 1) {
        buttonGroup.addButton(chooseAnswer[plasmaHack].nativeWidget());
    }
    /// End Hack
    layout->addItem(&abort, 5, 0, 1, 1, Qt::AlignCenter);
    layout->addItem(&submit, 5, 2, 1, 1, Qt::AlignCenter);
    setLayout(layout);
}

#include "quizquestion.moc"
