/***************************************************************************
 *   Copyright 2008 by Beat Wolf <asraniel@fryx.ch>                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

// Here we avoid loading the header multiple times
#ifndef SERVERAPPLET_HEADER
#define SERVERAPPLET_HEADER
// We need the Plasma Applet headers
#include <plasma/applet.h>

#include "configuration.h"

#include <QActionGroup>
#include <KIcon>

#include <QLabel>
#include <QWidget>
#include <QVBoxLayout>


// Define our plasma Applet
class ServerApplet : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        ServerApplet(QObject *parent, const QVariantList &args);
        ~ServerApplet();
        void init();

    public slots:
        void openService(QAction * action);
        void showConfigurationInterface();

    private:
        void constructServices();

        QString m_name;
        QString m_address;
        QString m_username;
        QActionGroup *m_services;
        QList<struct service> *m_base_services;

        KIcon* m_icon;
        QLabel *m_name_label;
        QWidget *m_actions;
        QVBoxLayout *layout_actions;
};

// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(serverhotlink, ServerApplet)
#endif
