/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef TIMETRACKERVIEW_H
#define TIMETRACKERVIEW_H

#include <Plasma/Applet>
#include <Plasma/LineEdit>
#include <Plasma/TextBrowser>
#include <Plasma/TabBar>
#include <Plasma/PushButton>
#include <Plasma/Label>
struct Jobs{
  time_t  m_time;
  QString m_text;
  char    m_count;
  
  enum type{Work, FreeTime, NonCountableFreeTime};
  
  Jobs(time_t t, QString& text, int typeOfWork) : m_time(t), m_text(text), m_count(typeOfWork){}
  
};

class TimeTrackerView : public Plasma::Applet
{
  Q_OBJECT
public:
    TimeTrackerView(QGraphicsItem* parent = 0, const QString& serviceId = QString(), uint appletId = 0);
    
private:
    Plasma::TabBar 	*m_tabbar;
    Plasma::LineEdit 	*m_finishedJob;
    Plasma::TextBrowser *m_jobs;
    Plasma::PushButton  *m_btnSendJobs;
    Plasma::Label	*m_wastedTime;
    Plasma::Label	*m_workedTime;
    
    time_t t_wasted;
    time_t t_worked;
    time_t t_startedAt;
    
    QList<Jobs> m_jobList;
    
    void saveCurrentInformation();

public slots:
    void updateTimeStamps();
    
};

#endif // TIMETRACKERVIEW_H
