class Url_Proxy < Qt::GraphicsProxyWidget
        signals 'textChanged(QString)',
                'returnPressed(QString)'
        def initialize(url,top)
		super top
		setWidget(url)
                @url = url
		url.setAttribute(Qt::WA_NoSystemBackground)
		setSizePolicy(Qt::SizePolicy::Expanding, Qt::SizePolicy::Fixed)
		url.setSizePolicy(Qt::SizePolicy::Expanding, Qt::SizePolicy::Fixed)
		connect(@url, SIGNAL('textChanged(QString)'), self, SIGNAL('textChanged(QString)'))	
		connect(@url, SIGNAL('returnPressed(QString)'), self, SIGNAL('returnPressed(QString)'))
        end
end

class TransparentFrame < Qt::GraphicsWidget
	def initialize(par, imgpath)
		super par
	end
	def paintInterface(p, opts, rect)
		return
	end
end

#Basically this class is a Qt Label with glowey effects and a plasma theme applied to it the same way plasma does it
#then it's set as the plasma labels 'nativeWidget'
#It also extends links to the rest of the widget - meaning, if you hover a link
#then click anywhere else on the widget without leaving the widget, the link is activated
#this allows command links etc to be clicked anywhere that's "glowing"

class MyQtLabel < Qt::Label
	slots	'linkHovered(QString)',
		'animate()'
	signals 'clickedOn(QString)'
	def initialize(par = nil, top=nil)
		super par
		@top = top
		@currentLink = ""
		@InsideWidget = false
		@brightness = 0
                @myTimer = Qt::Timer.new()
                Qt::Object.connect(@myTimer, SIGNAL('timeout()'), self, SLOT('animate()'))
		setAutoFillBackground true
		setWordWrap(true)

		setStyleSheet("")
		@top.setStyleSheet("")
		connect(self, SIGNAL("linkHovered(QString)"), self, SLOT("linkHovered(QString)") )
# Connect the native widget's linkActivated to the plasma widget's signal..
		connect(self, SIGNAL('clickedOn(QString)'), @top, SIGNAL('linkActivated(QString)') )


# Stuff for the glowey label animation
		@waveup = true # false is down, true is up
		@wave = 0.to_f
		@factor = 250/25
		@factor = @factor.to_f
		@wavetop = 60.to_f # The higher this is, the less alpha is given - must be greater than maxRise+maxWave
		@maxRise = 25.to_f # The beginning rise before wave takes over
		@maxWave = 30.to_f # The height of the wave
		@one = 1.to_f

		@backgroundimage = @top.top.backgroundImage
		@backgroundimage.setElementPrefix("hover")
		@mypixmap = nil
		@animating = false
		@point = Qt::Point.new(0,0)
		@painter = Qt::Painter.new()
	end
	def  linkHovered(s)
		if(s != nil)
			@currentLink=s
			@InsideWidget = true
			if(@animating == false)
				startAnimate()
				@animating = true;
			end
		end
	end
	def mousePressEvent(e)

		if (@InsideWidget)
			emit clickedOn(@currentLink)

		end
	end
	def generatePalette(backgroundcolor=nil)
                @mycolor = Plasma::Theme::defaultTheme().color(Plasma::Theme::TextColor);
                setFont(Plasma::Theme::defaultTheme().font(Plasma::Theme::DefaultFont));
		p = palette()
		p.setColor(Qt::Palette::Normal, Qt::Palette::WindowText, @mycolor);
		p.setColor(Qt::Palette::Inactive, Qt::Palette::WindowText, @mycolor);
		setPalette(p)
	
	end
	def enterEvent(e)
		super(e)
		# Don't do anything on enter...
	end
	def resizeEvent(e)
		@backgroundimage.resizeFrame(Qt::SizeF.new(size))
		@backgroundimage.setElementPrefix("hover")
		@mypixmap = @backgroundimage.framePixmap
		super(e)
	end
	def paintEvent(e)
		if @mypixmap == nil
			super(e)
			return
		end
		@painter.begin(self)
# Don't set it to source!!! screws up transparency bad...
#		@painter.setCompositionMode(Qt::Painter::CompositionMode_Source)
		@painter.opacity = (@wave+@brightness)/@wavetop
		if @painter.opacity != 0
			@painter.drawPixmap(@point,@mypixmap)
		end
		@painter.end
		super e
	end
	def leaveEvent(e)
		@InsideWidget = false
	end
	def startAnimate()
		@myTimer.start 30
	end
	def animate()
		if (@InsideWidget) == true
			if(@brightness < @maxRise and @wave == 0)
				@brightness = @brightness + @one
			else
				if(@waveup)
					@wave = @wave + @one
					if (@wave >= @maxWave) 
						@waveup = false
					end			
				else
					@wave = @wave - @one
					if( @wave <= 0)
						@waveup = true
					end
				end
					
			end
		else
			# only animate until the animation is off, then stop the timer
			if @wave != 0
				@wave = @wave - @one
			end
			if @brightness > 0 and @wave <= 0
				@brightness = @brightness - @one
			else
				if @wave <= 0
					@wave = 0
					@waveup = true
					@myTimer.stop
					@animating = false
				end
			end
		end
		update()
	end

end
class GloweyLabel < Plasma::Label
	slots	'linkHovered()',
		'timeout()'
	signals 'linkActivated(QString)'
	attr_accessor :top
	attr_accessor :labelWidget
	def initialize(top, par=nil, setMax=true)
		super nil
		@top = top
		@stylesheet = "* {border: 0; margin: 0; padding: 0; text-decoration: none;} a:link, a:visited, a:hover {text-decoration: none;}"
		@labelWidget = MyQtLabel.new(nil, self)
		@labelWidget.setAttribute(Qt::WA_NoSystemBackground, true)

		self.setAttribute(Qt::WA_NoSystemBackground, true)
		setStyleSheet(@stylesheet)
		@labelWidget.setWordWrap(true)
		setWidget(@labelWidget)
		@labelWidget.generatePalette()
		self.setMinimumSize(160,130)
		if(setMax)
			self.setMaximumSize(167722,130)
		end
	end
	def setMaximumSize(x, y)
		super(x,y)
		@labelWidget.setMaximumSize(x, y)
	end
        def setMinimumSize(x, y)
                super(x,y)
                @labelWidget.setMinimumSize(x, y)
        end
	def paint(p, opt, widg)
		puts 'paint Label Interface'
		super(p,opt,widg)
	end
	def setLabelText(s)
		color = KDE::GlobalSettings.activeTextColor.name()
		s = s.gsub("a href=", "a style='text-decoration: none;color:" + color.to_s + ";' href=")
		@labelWidget.text = s
	end
end
class WebButton < Plasma::PushButton
	def initialize(par = nil)
		super par
	end
	def setLabelText(s)
		setText s
	end
end
class ResizeFrame < TransparentFrame
	def initialize(par, imgpath)
		super(par,imgpath)
		@top = par
		
	end
	def setLayout(l)
		@layout = l
	end
	def resizeEvent(e)
		super(e)
		diff = @top.size().width()-723
		diff = diff/8
		@layout.setSpacing(15+diff)
	end
end
