/*
*   Copyright (C) 2009 Matteo Agostinelli <agostinelli@gmail.com>
*   Copyright (C) 2007 Barış Metin <baris@pardus.org.tr>
*   Copyright (C) 2006 David Faure <faure@kde.org>
*   Copyright (C) 2007 Richard Moore <rich@kde.org>
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU Library General Public License version 2 as
*   published by the Free Software Foundation
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details
*
*   You should have received a copy of the GNU Library General Public
*   License along with this program; if not, write to the
*   Free Software Foundation, Inc.,
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef QALCULATERUNNER_H
#define QALCULATERUNNER_H

class QalculateEngine;
class QTimer;

#include <Plasma/AbstractRunner>

class QalculateRunner : public Plasma::AbstractRunner
{
Q_OBJECT

public:
    QalculateRunner(QObject* parent, const QVariantList &args);
    ~QalculateRunner();

public slots:
    void match(Plasma::RunnerContext &context);
    
protected slots:
    QString calculate(const QString& term);

private:   
    QalculateEngine* m_engine;
};

K_EXPORT_PLASMA_RUNNER(qalculate_runner, QalculateRunner)

#endif
