/*
 *   Copyright 2008 Aike J Sommer <dev@aikesommer.name>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2,
 *   or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#include <KDebug>

#include "configurationsservice.h"

#include <kephal/configurations.h>
#include <kephal/kephal.h>


ConfigurationsService::ConfigurationsService(QObject * parent)
    : Plasma::Service(parent)
{
    setName("screens-configurations");
}

Plasma::ServiceJob * ConfigurationsService::createJob(const QString & operation, QMap<QString,QVariant> & parameters)
{
    kDebug() << "Job" << operation << "with arguments" << parameters << "requested";
    return new ConfigurationsServiceJob(operation, parameters, this);
}



ConfigurationsServiceJob::ConfigurationsServiceJob(const QString & operation,
        QMap<QString,QVariant> & parameters, QObject* parent)
    : ServiceJob("configurations", operation, parameters, parent)
{
}

void ConfigurationsServiceJob::start() {
    const QString operation = operationName();
    
    if (operation == "confirm") {
        Kephal::Configurations::self()->confirm();
    } else if (operation == "revert") {
        Kephal::Configurations::self()->revert();
    }
    
    emitResult();
}
