#ifndef QEDJEWALLPAPER_HEADER
#define QEDJEWALLPAPER_HEADER

#include "plasma/wallpaper.h"
#include <qedje.h>
#include <qzion.h>

#include "ui_config.h"


class QEdjeWallpaper : public Plasma::Wallpaper
{
    Q_OBJECT
public:
    QEdjeWallpaper(QObject* parent, const QVariantList& args);
    ~QEdjeWallpaper();

    virtual void paint(QPainter* painter, const QRectF& exposedRect);
    virtual QWidget* createConfigurationInterface(QWidget* parent);
    virtual void save(KConfigGroup &config);

protected:
    virtual void init(const KConfigGroup &config);

protected slots:
    void canvasUpdated(const QRegion &r);
    void configWidgetDestroyed(QObject*);

private:
    QEdje *world;
    QZionCanvas *canvas;

    QPixmap m_pixmap;
    QString m_edje_file;
    const QString m_edje_group;

    QWidget *m_configWidget;
    Ui::Config m_ui;
};

#endif
