#ifndef EDGESOURCE_H
#define EDGESOURCE_H

#include <QGraphicsItem>
#include <QVariant>
#include <QSet>

class Edge;
class ShadowItem;

class EdgeSource : public QGraphicsItem
{
public:
    EdgeSource();
    ~EdgeSource();
    void addEdge(Edge *e);
    void removeEdge(Edge *e);

    void setShadow(ShadowItem *item);
    ShadowItem *shadow() const;
protected:
    QVariant itemChange(GraphicsItemChange change, const QVariant &value);
protected:
    QSet<Edge*> m_edges;
    ShadowItem  *m_shadow;
};

#endif
