
#include "filtertreewidget.h"

#include <QHeaderView>
#include <QMimeData>


FilterTreeWidget::FilterTreeWidget(QWidget* parent) : QTreeWidget(parent)
{
    header()->hide();
}

QStringList FilterTreeWidget::mimeTypes() const
{
    return QStringList() << "x-quasar/nodelist";
}

QMimeData* FilterTreeWidget::mimeData(const QList<QTreeWidgetItem*> items) const
{
    QMimeData* md = new QMimeData;
    QByteArray data;
    QDataStream stream(&data, QIODevice::WriteOnly);
    foreach (QTreeWidgetItem* item, items)
    {
        if (!item->parent())
            continue;
        stream << QString("/%1/%2").arg(item->parent()->text(0), item->text(0));
    }
    md->setData("x-quasar/nodelist", data);
    return md;
}

Qt::DropActions FilterTreeWidget::supportedDropActions() const
{
    return Qt::CopyAction;
}


