#include "gaussianblur_p.h"

using namespace Quasar;

GaussianBlurNode::GaussianBlurNode()
    : ConvolutionNode("/blur/gaussian")
{
}

void GaussianBlurNode::fillConvolution(GLint *k, GLfloat *scale,
                                       QColor *baseColor)
{
    Q_ASSERT(m_kernelSize == 9);

    k[0] = 1; k[1] =  2; k[2] = 1;
    k[3] = 2; k[4] =  4; k[5] = 2;
    k[6] = 1; k[7] =  2; k[8] = 1;

    *scale = 1.0/16.0;
}
