#include "imageoutput_p.h"

#include "texture.h"

#include <QImage>
#include <QGLContext>
#include <qdebug.h>

using namespace Quasar;

ImageOutputNode::ImageOutputNode()
    : Node("Image Output")
{
    Quasar::Property tex = {
        Quasar::Property::InputProperty,

        QString::fromLatin1("texture"),
        QVariant::UserType,
        QVariant(),
        QString::fromLatin1("Loaded texture"),

        QVariant(),
        QVariant(),
        QVariant(),
    };
    addProperty(QString::fromLatin1("texture"), tex);

    Quasar::Property prop = {
        Quasar::Property::OutputProperty,

        QString::fromLatin1("image"),
        QVariant::Image,
        QImage(),
        QString::fromLatin1("Saved image"),

        QImage(),
        QVariant(),
        QVariant(),
    };
    addProperty(QString::fromLatin1("image"), prop);
}

bool ImageOutputNode::execute()
{
    //bind();
    QVariant res = propertyValue("texture");
    Texture tex = qvariant_cast<Texture>(res);
    QImage img = tex.toImage();
#if 0
    qDebug()<<"Texture is "<<tex.id();
    img.save("aaaaaaaa.png");
    qDebug()<<"\timg null = "<<img.isNull();
#endif
    outputReady(QString::fromLatin1("image"), img);
    return !img.isNull();
}
